=== debian/changelog ===
suitesparse (1:5.10.1+dfsg-4build1) jammy; urgency=high

  * No change rebuild for ppc64el baseline bump.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 25 Mar 2022 10:52:16 +0100

suitesparse (1:5.10.1+dfsg-4) unstable; urgency=medium

  * Add Recommends on libgraphblas-{dev,doc}

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 10 Dec 2021 09:52:48 +0100

suitesparse (1:5.10.1+dfsg-3) unstable; urgency=medium

  * Stop building and providing GraphBLAS.
    It is now provided by a new separate source package, suitesparse-graphblas.
    In particular:
    * Drop libgraphblas5 package
    * Drop graphblas-build.patch and libatomic.patch
    * New do-not-build-graphblas.patch

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 26 Nov 2021 11:19:54 +0100

suitesparse (1:5.10.1+dfsg-2) unstable; urgency=medium

  * Re-upload as source-only, since previous upload was source+binary
    because it had to pass NEW

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 05 Sep 2021 09:57:49 +0200

suitesparse (1:5.10.1+dfsg-1) unstable; urgency=medium

  * New upstream version 5.10.1+dfsg
  * SOVERSION bump for GraphBLAS (4 → 5)
  * Bump to S-V 4.6.0

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 01 Sep 2021 18:15:19 +0200

suitesparse (1:5.9.0+dfsg-1) experimental; urgency=medium

  * New upstream version 5.9.0+dfsg
  * d/copyright: reflect upstream changes
  * sliplu-doc.patch: drop patch, no longer needed
  * SOVERSION bump for GraphBLAS (3 → 4)
  * Bump to S-V 4.5.1

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 01 May 2021 20:48:20 +0200
